
import networkx as nx
from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
def createGraph(input_path):
    C_S = int(input("Enter the 1 for Clique ; 2 for Star ; 3 for Chain ; 4 for bipartite and 5 for mix."))
    
    if C_S==1 :
        num_clique = int(input("Enter the number of cliques."))
        clique_nodes = int(input("Enter the number of nodes in each clique."))
        
        ############## Clique I #####################
        g = nx.Graph()
        for i in range(1,clique_nodes+1):
            for j in range(1,clique_nodes+1):
                if i!=j:
                    g.add_edge(i,j)
                    g.add_edge(j,i)
        
        for k in range(1,num_clique):
            h = nx.Graph()
            for i in range(1,clique_nodes+1):
                for j in range(1,clique_nodes+1):
                    if i!=j:
                        h.add_edge(i,j)
                        h.add_edge(j,i)
            
            c = nx.disjoint_union(g,h)
            g=c
        filename="clique_"+str(clique_nodes)+"_"+str(num_clique)+".csv"
        nx.write_edgelist(g, input_path+"/"+filename, delimiter = ",",data=False)
        '''
        ############## Clique II #####################
        g = nx.Graph()
        for i in range(1,clique_nodes+1):
            for j in range(1,clique_nodes+1):
                if i!=j:
                    g.add_edge(i,j)
                    g.add_edge(j,i)
        
        for k in range(1,num_clique):
            h = nx.Graph()
            for i in range(1,clique_nodes+1):
                for j in range(1,clique_nodes+1):
                    if i!=j:
                        h.add_edge(i,j)
                        h.add_edge(j,i)
            
            c = nx.disjoint_union(g,h)
            g=c
            g.add_edge(k*clique_nodes-1,k*clique_nodes)
            
        filename1="clique_"+str(clique_nodes)+"_"+str(num_clique)+"_joint.csv"   
        nx.write_edgelist(g, input_path+"/"+filename1, delimiter = ",",data=False)
        '''
    if C_S==2:
     
        num_star = int(input("Enter the number of star."))
        star_nodes = int(input("Enter the number of nodes in each star."))
        
        ############## Star I #####################
        g = nx.Graph()
        for i in range(1,2):
            for j in range(1,star_nodes+1):
                if i!=j:
                    g.add_edge(i,j)
                    g.add_edge(j,i)
        for k in range(1,num_star):
            h = nx.Graph()
            for i in range(1,2):
                for j in range(1,star_nodes+1):
                    if i!=j:
                        h.add_edge(i,j)
                        h.add_edge(j,i)
            
            c = nx.disjoint_union(g,h)
            g=c
        filename="star_"+str(star_nodes)+"_"+str(num_star)+"_1.csv"
        nx.write_edgelist(g, input_path+"/"+filename, delimiter = ",",data=False)
        
    if C_S==3:
     
        num_star = int(input("Enter the number of lines."))
        star_nodes = int(input("Enter the number of nodes in each line."))
       
        ############## Star I #####################
        g = nx.Graph()
        for i in range(1,star_nodes):
            g.add_edge(i,i+1)
            g.add_edge(i+1,i)
        for k in range(1,num_star):
            h = nx.Graph()
            for i in range(1,star_nodes):
                h.add_edge(i,i+1)
                h.add_edge(i+1,i)
            
            c = nx.disjoint_union(g,h)
            g=c
        filename="line_"+str(star_nodes)+"_"+str(num_star)+".csv"
        nx.write_edgelist(g, input_path+"/"+filename, delimiter = ",",data=False)
    if C_S==4:
        #Bi-Partite
        num_bp= int(input("Enter the number of Bi-Partite graphs: "))
        group1 = int(input("Enter the number of nodes in Group1 of Bi-Partite: "))
        nodes1 = [number for number in range(1, group1 +1)]
        group2 = group1 + int(input("Enter the number of nodes in Group2 of Bi-Partite: "))
        nodes2 = [number for number in range(group1+1, group2 +1)]

        g = nx.Graph()
        for i in nodes1:
            for j in nodes2:
                g.add_edge(i,j)
                
        for k in range(1,num_bp):
            h = nx.Graph()
            for i in nodes1:
                for j in nodes2:
                    h.add_edge(i,j)
            c = nx.disjoint_union(g,h)
            g=c
        
        
        filename="bp_"+str(group1)+"_"+str(group2)+".csv"
        nx.write_edgelist(g, input_path+"/"+filename, delimiter = ",",data=False)
    if C_S==5:       
        ############## Clique I #####################
        
        g = nx.Graph()
        vals = input("Enter the number of cliques,star,chain and bp required in format [fc,st,ch,bp]=30,20,10,10.")
        num_val=vals.split(',')
        node_size = input("Enter the number of nodes in cliques,star,chain and bp required in format [fc,st,ch,bpg1,bpg2]=20,30,30,20,20.")
        num_node_size=node_size.split(',')
        ############## Clique I #####################
        g = nx.Graph()
        num_clique=int(num_val[0])
        clique_nodes=int(num_node_size[0])
        for i in range(1,clique_nodes+1):
            for j in range(1,clique_nodes+1):
                if i!=j:
                    g.add_edge(i,j)
                    g.add_edge(j,i)
        
        for k in range(1,num_clique):
            h = nx.Graph()
            for i in range(1,clique_nodes+1):
                for j in range(1,clique_nodes+1):
                    if i!=j:
                        h.add_edge(i,j)
                        h.add_edge(j,i)
            
            c = nx.disjoint_union(g,h)
            g=c
        ############## Star I #####################
        star_nodes=int(num_node_size[1])
        num_star=int(num_val[1])
        h = nx.Graph()
        for i in range(1,2):
            for j in range(1,star_nodes+1):
                if i!=j:
                    h.add_edge(i,j)
                    h.add_edge(j,i)
        for k in range(1,num_star):
            h1 = nx.Graph()
            for i in range(1,2):
                for j in range(1,star_nodes+1):
                    if i!=j:
                        h1.add_edge(i,j)
                        h1.add_edge(j,i)
            
            c = nx.disjoint_union(h,h1)
            h=c            
        g = nx.disjoint_union(g,h)   
        ############## Line I #####################
        line_nodes=int(num_node_size[2])
        num_line=int(num_val[2])
        h = nx.Graph()
        for i in range(1,line_nodes):
            h.add_edge(i,i+1)
            h.add_edge(i+1,i)
        for k in range(1,num_line):
            h1 = nx.Graph()
            for i in range(1,line_nodes):
                h1.add_edge(i,i+1)
                h1.add_edge(i+1,i)
            
            c = nx.disjoint_union(h,h1)
            h=c 
            
        g = nx.disjoint_union(g,h) 
         ############## #Bi-Partite ##############
        num_bp= int(num_val[3])
        group1 = int(num_node_size[3])
        nodes1 = [number for number in range(1, group1 +1)]
        group2 = int(num_node_size[4])
        nodes2 = [number for number in range(group1+1, group2 +1)]

        h = nx.Graph()
        for i in nodes1:
            for j in nodes2:
                h.add_edge(i,j)
                
        for k in range(1,num_bp):
            h1 = nx.Graph()
            for i in nodes1:
                for j in nodes2:
                    h1.add_edge(i,j)
            c = nx.disjoint_union(h,h1)
            h=c
                
        g = nx.disjoint_union(g,h) 
        
        noNodes=clique_nodes+star_nodes+line_nodes+group1+group2
        numStru=num_clique+num_star+num_line+num_bp
        filename="Mix_"+str(noNodes)+"_"+str(numStru)+".csv"
        nx.write_edgelist(g, input_path+"/"+filename, delimiter = ",",data=False)
    print('Creation of graph Done and file name is : ') 
    print('*'+filename)

def main(): 
 # parser = ArgumentParser("code",formatter_class=ArgumentDefaultsHelpFormatter,conflict_handler='resolve')
  #parser.add_argument("-pathofFile", required=True, help='Output File Path')
   
 # args = parser.parse_args()
  
  input_path =  "scale" #11args.pathofFile
  createGraph(input_path)
  
      

if __name__=='__main__':
  main()
