
import numpy as np
import networkx as nx
import subprocess as commands
import multiprocessing
import itertools
import community
from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
def make_tensor_undirected (G,output_file,nworker):
  cnt=1
  map_dict=dict()
  map_tensor2node = np.zeros(len(G.nodes()))
  for n in G.nodes():
    map_dict[n]=cnt
    map_tensor2node[cnt-1]=n
    cnt=cnt+1
  list_nodes_all=G.nodes()
  slice_size=len(list_nodes_all)/int(nworker)
  slices_nodes =slices(G.nodes(),slice_size)

  cnt=0
  for pr in slices_nodes:
    exec('p'+str(cnt)+' = multiprocessing.Process(target=sub_undirected, args=(G,map_dict,pr,cnt,output_file))')
    exec('p'+str(cnt)+'.start() ')
    cnt=cnt+1
  num_proc=cnt

  for cnt in range(num_proc):
    exec('p'+str(cnt)+'.join() ')
    cnt=cnt+1

  with open(output_file, 'w') as f :
    for index in range(num_proc):
      content = open(output_file+str(index)+'.txt','r').read()
      f.write(content)
      f.write('\n')
      cmd = 'rm '+output_file+str(index)+'.txt'
      (status,output) =   commands.getstatusoutput(cmd)
      if status:
        print ('Error in deleting subprocess output file copy')
     
  f.close()
  print ('***** Output file is saved at -> ' + output_file + ' *****')



def make_tensor_directed (G,output_file,nworker):

  #open(output_file, 'w')
  cnt=1
  map_dict=dict()
  map_tensor2node = np.zeros(len(G.nodes()))
  for n in G.nodes():
    map_dict[n]=cnt
    map_tensor2node[cnt-1]=n
    cnt=cnt+1
  list_nodes_all=G.nodes()

  slice_size=len(list_nodes_all)/int(nworker-1)
  slices_nodes =slices(G.nodes(),slice_size)

  
  cnt=0
  for pr in slices_nodes:
    exec('p'+str(cnt)+' = multiprocessing.Process(target=sub_directed, args=(G,map_dict,pr,cnt,output_file))')
    exec('p'+str(cnt)+'.start() ')
    cnt=cnt+1
  num_proc=cnt

  for cnt in range(num_proc):
    exec('p'+str(cnt)+'.join() ')
    cnt=cnt+1


  with open(output_file, 'w') as f :
    for index in range(num_proc):
      content = open(output_file+str(index)+'.txt','r').read()
      f.write(content)
      f.write('\n')
      cmd = 'rm '+output_file+str(index)+'.txt'
      (status,output) =   commands.getstatusoutput(cmd)
      if status:
        print ('Error in deleting subprocess output file copy')

     
  f.close()
  print ('***** Output file is saved at -> ' + output_file + ' *****')

def slices(L, n):
  list_out=list()
  L=list(L)

  for i in range(0, len(L), int(n)):
    
    list_out.append( L[i:i + int(n)])
  return list_out

def sub_directed(G,map_dict,list_nodes,index,output_file):
  print ('in subprocess '+ str(index)+' **')
  with open(output_file+str(index)+'.txt', 'w') as f :
    for n in list_nodes:
    
      neigh_n = G.neighbors(n)
      neigh_n.append(n)
      Gn = nx.subgraph(G,neigh_n)
      for m in Gn.nodes():
        Gn.add_edge(m,m)
      edg = [(map_dict[n],map_dict[e[0]],map_dict[e[1]]) for e in Gn.edges()]
      f.write(('\n').join('%d %d %d 1' % x for x in edg))
      f.write(('\n'))
  f.close()
  print ('finishing subprocess '+ str(index)+' **\n')




def sub_undirected(G,map_dict,list_nodes,index,output_file):
  print ('** Processing subprocess '+ str(index)+' **')
  with open(output_file+str(index)+'.txt', 'w') as f :
    for n in list_nodes:
    
      neigh_n = list(G.neighbors(n))
      neigh_n.append(n)
      Gn = nx.Graph(nx.subgraph(G,neigh_n))
      
      
      for m in Gn.nodes():
        Gn.add_edge(m,m)
      edg2= [(map_dict[n],map_dict[e[1]],map_dict[e[0]]) for e in Gn.edges()]    
      edg = [(map_dict[n],map_dict[e[0]],map_dict[e[1]]) for e in Gn.edges()]
      f.write(('\n').join('%d %d %d 1' % x for x in edg))
      f.write(('\n'))
      f.write(('\n').join('%d %d %d 1' % x for x in edg2))
      f.write(('\n'))
  f.close()
  print ('** Finishing subprocess '+ str(index)+' **\n')
  
def edgelist2networkxG_undirected(input_adj):
  G = nx.Graph()
  f =open(input_adj,'rU')
  
  lines = f.read().splitlines()
  for l in lines:
    if l[0]!='#':
      e = tuple(l.split(',')) 

      if len(e)> 1:
        ee = (int(e[0]) ,int(e[1]))
        G.add_edge(*ee)
  print('Loading text file data into networkx undirected graph done')
  return G

def edgelist2networkxG_directed(input_adj):
  G = nx.DiGraph()
  f =open(input_adj,'rU')
 
  lines = f.read().splitlines()
  for l in lines:
    if l[0]!='#':
      e = tuple(l.split(',')) 

      if len(e)> 1:
        ee = (int(e[0]) ,int(e[1]))
        G.add_edge(*ee)
  print('Loading text file data into networkx directed graph done')
  return G

def createTensor(input_adj,directed_graph,outfileName,nworkers):  

  if directed_graph==1:
    G=edgelist2networkxG_directed(input_adj)
    make_tensor_directed(G,outfileName,nworkers)
    print('Creating communities for geting indexes')
    communityDetection(G,outfileName)
  else:
    G=edgelist2networkxG_undirected(input_adj)
    make_tensor_undirected(G,outfileName,nworkers)
    print('Creating communities for geting indexes')
    communityDetection(input_adj,outfileName)

 
  return 

def communityDetection(input_adj,outfileName):
    G=nx.read_edgelist(input_adj, nodetype=int, delimiter=',')
    comp= community.best_partition(G)
    #comp1 = nx.algorithms.community.label_propagation.label_propagation_communities(G)
    #print(type(comp1))
    #for val in comp1:
        #print(sorted(val))
    with open(outfileName[:-4]+'_labels.txt', 'w') as f :
      for key,val in comp.items() :
            strVal=str(key) + ' ' +str(val)
            f.write(strVal)
            f.write('\n')

    f.close()

    print('***** Label file is also ready ***')

def main(): 
  parser = ArgumentParser("createTensor",formatter_class=ArgumentDefaultsHelpFormatter,conflict_handler='resolve')
  parser.add_argument("-input", required=True, help='Input Edge  File')
  parser.add_argument("-output", required=False,default='OutputTensor.txt' ,help='Output File Name')
  parser.add_argument("-d", required=True,default=0, type=int, help='Directed=1 or Undirected=0, default value is set to 0.')
  parser.add_argument("-nw", required=False,default=1, type=int, help='Number of subprocess. For large file set it > 1 and for small file set it to 1. Default value is set to 1.')
  args = parser.parse_args()
  
  input_adj =  args.input
  directed_graph = args.d
  outfileName='TensorFiles/'+args.output
  nworkers=args.nw
  
  createTensor(input_adj,directed_graph,outfileName,nworkers)
      

if __name__=='__main__':
  main()
