clear all;clc;close all;
addpath('tensor_toolbox');
addpath('tensorlab');
%% create synthetic graph. If using real data, comment the below line
% graphFileName=richcomm_getStructureGraph('InputGraphFiles');


%% for REAL Data, give graph file name here and location is InputGraphFiles
graphFileName='football_adj.txt'; %If using real data, un-comment this line 
inputFile=strcat('InputGraphFiles\', graphFileName);
outTenFile=strcat(graphFileName(1:end-4),'_tensor.txt') ;  
%% initilize parameters
         ops.constraint{1} = 'sparsity';
         ops.constraint{2} = 'sparsity';
         ops.constraint{3} = 'sparsity';
         ops.la = 0.001;
         ops.l1 = 0.01;
         R=5;  L=10*ones(1,R);
         d=0; nw=5; 
%% Create tensor from graph data file
% set d=0 for undirected graphs and nw to 1 for small files otherwise > 1.
[X,Y,Xmat]=richcomm_getData(inputFile,outTenFile,d,nw,0);
clear d nw ans strval

 %% run code
 [Fac,timeSpent,~,model,orderedMatrix] = richcomm(X,L,Y,ops);
 
 
 %% saving model in files
 fprintf('time taken : %5.5f seconds.\n',timeSpent);
 save(strcat('Output_Model/',outTenFile(1:end-4),'_model.mat'),'model');
 disp('Model saved in Output_Model/Model.mat file');
 %% Visulization of model and saving it in txt file
 f=input('Do you want to print community structure and save each community structure in txt file \n');
 if f==1
    [FigH]=richcomm_plotComm(model,X,orderedMatrix);
    richcomm_printModel(model,strcat('Output_Model/',outTenFile(1:end-4),'_model.txt')) ;
 end
 disp("************************** DONE **************************");
 clear  orderedMatrix f  

 

 
 
 
 