%"Beyond Rank-1: Discovering Rich Community Structure in Multi-Aspect Graphs" 
function [FigH]=richcomm_plotComm(model,X,orderedMatrix)
         FigH = figure;N=1; idx=zeros(0,0);
         for i = 1 : length(model)
              curind=model(i).Nodes;
              if size(curind,2)>1
                idx(N)=i;N=N+1;
              end
         end
         N=N-1;
         sq=floor(sqrt(N))+1;
         for i = 1 : N
            model_idx=model(idx(i));
            titleName=model_idx.Structure;
            curind=model_idx.Nodes;
            curindComm=model_idx.Comm;
            subplot(sq,sq,i);
                if curindComm==1
                     T=X(curind,curind,curind);
                else
                    T=orderedMatrix(curind,curind);
                end
                CommNodeColor=rand(1,3);
                commMarkersize=6;
                [FigH,~]=richcomm_getVisulization(T,CommNodeColor,commMarkersize,FigH);
                hold on;
                title(titleName);
         end 
         hold off;
end
function [FigH,G]=richcomm_getVisulization(T,CommNodeColor,commMarkersize,FigH)
    dims=size(T);
    if size(dims,2)==2
    else
        TT=sparse(dims(1),dims(2));
        for i =1:dims(3)
            TT=TT+double(T(:,:,i));
        end
        T=TT;
    end
    T(T~=0)=1;
    if issymmetric(T)
    else
       T=T+T';T(T~=0)=1;
    end
    T=T-diag(diag(T));
    [row,col]=find(T==1);
    SampleEdgeList=[row  col];
    uniqueEdgeList = unique(sort(SampleEdgeList,2),'rows');
    EdgeTable = table(uniqueEdgeList,ones(size(uniqueEdgeList,1),1),'VariableNames',{'EndNodes' 'Weight'});
   
    G = graph(EdgeTable);
    LineH=plot(G,'EdgeColor',[0 0 0],'MarkerSize',commMarkersize,'NodeColor',CommNodeColor); %CommNodeColor=Red [1 0 0]; 
    FigH  = ancestor(LineH, 'figure');
end