%"Beyond Rank-1: Discovering Rich Community Structure in Multi-Aspect Graphs"
function richcomm_printModel(model,outfile)
 N=length(model);
 disp("FC NC ST CH CB NB Other");
 FC=0;NC=0;ST=0;CH=0;CB=0;NB=0;other=0;
 for i = 1 : N
            model_idx=model(i);
            titleName=model_idx.Structure;
            if titleName=="Full Clique"
                FC=FC+1;
            elseif titleName=="Near Clique"
                NC=NC+1;
            elseif titleName=="Chain"
                CH=CH+1;
            elseif titleName=="Star"
                ST=ST+1;
            elseif titleName=="Bipartite (special case: star)"
               ST=ST+1;
            elseif titleName=="Bipartite"
                CB=CB+1;
            elseif titleName=="Near Bipartite"
                NB=NB+1;
            elseif titleName=="Chain or Star"
                ST=ST+1; 
            else
                other=other+1;
            end

 end
 fprintf('%d %d %d %d %d %d %d\n',FC,NC, ST, CH, CB, NB,other);
 printStructureToModelFile( model, outfile);
 disp('Model Saved in file...')
end

function printStructureToModelFile(model, outfile)
fid = fopen(outfile, 'wt');
for i = 1 : length(model)
    model_idx = model(i);
    titleName = model_idx.Structure;
    nodes1 = model_idx.Nodes';
    nodes2 = model_idx.extranodes';
    fprintf(fid, '%s,', titleName);
    fprintf(fid, '['); fprintf(fid, '%d,', nodes1); fprintf(fid, '],');
    fprintf(fid, '['); fprintf(fid, ' %d,', nodes2); fprintf(fid, '],');
    fprintf(fid, '\n');
end
fclose(fid);
end
